//        
#define F_CPU 16000000UL  //  16 MHz

#include "LPH8731.h"
#include "hardware.h"
#include "ksh148.h"
#include "LC72131.h"
#include "encoder.h"
#include "eeprom.h"

#define ADC_BAT_NI_MH_75 800
#define ADC_BAT_NI_MH_50 700
#define ADC_BAT_NI_MH_25 560

#define ADC_BAT_AAx3_75  920
#define ADC_BAT_AAx3_50  720
#define ADC_BAT_AAx3_25  580

#define ADC_BAT_LION_75  760
#define ADC_BAT_LION_50  720
#define ADC_BAT_LION_25  680

#define RCV_MAX          855000
#define RCV_MIN          40000
#define SLEEP_MAX        20
#define SLEEP_MIN        3

unsigned char spectr_count = 0;
unsigned char step_spertr=59;
unsigned char k=0;
unsigned char marker_f=40;
unsigned char f_clear = FALSE;
unsigned char f_change = FALSE;

volatile uint8_t  dataLC[4];
unsigned char pwm = 0;

unsigned char Resiver_mode  = WFM_STEREO;      // 
unsigned char Stereo_in     = WFM_STEREO_IN;   //   
unsigned char Signal_IN     = WFM_IN;          //     fm  nfm   
volatile int  sleep_count   = 0;
volatile char sleep_countS  = 0;
volatile char f_sleep       = FALSE;
volatile unsigned int  adc_bat;  
volatile uint32_t  adc_bat_sum;
unsigned char adc_count = 0;
volatile char f_adc = 0;
uint32_t V_BAT = 0;                            //   
//0 
// 
volatile char f_press_butM  = FALSE;           //   
volatile char f_butM        = FALSE;           //   
volatile char f_butM_3c     = FALSE;           //       3 
volatile int  press_countM  = 0;  
// 
volatile char f_press_butS  = FALSE;           //   
volatile char f_butS        = FALSE;           //   
volatile char f_butS_3c     = FALSE;           //       3 
volatile int  press_countS  = 0;
// 
volatile  unsigned char Radio_Mode    = RADIO; //       
// /
unsigned char menu_radio    = SAVE;            //   /
uint16_t Mem_R_cell         = N_MEM_RADIO_MIN; //      
uint16_t Mem_W_cell         = N_MEM_RADIO_MIN; //      
unsigned char f_Memwrite    = FALSE; 
unsigned char f_SCAN        = FALSE; 
unsigned char f_SCAN_fist   = TRUE; 
//
unsigned char Bat_pow       = Bat_100;         // 
int           Bat_pow_int   = 0;  
// 
unsigned char menu_option   = APU;             //   
unsigned char APU_int       = 255;             //   
unsigned char N_View        = LI_ION;          // 
unsigned char ARU_int       = 255;             // 
volatile unsigned char Sleep_int     = 10;     //     

volatile int state_count    = 0;               //  
volatile char f_state       = FALSE;           //     
  
//------------------------------------------------------------------------------//
//-----------------------------   ----------------//
//------------------------------------------------------------------------------//
//---------  -----------
void DiplayBatState(void)
{
  //char *Bat_pow_int_str;
  unsigned char *Bat_state = (unsigned char *)Battery0;
  //      
  switch(Bat_pow)
  {
     case Bat_75:
	      Bat_state = (unsigned char *)Battery100;   break;
	 case Bat_50:
          Bat_state = (unsigned char *)Battery50;    break;
	 case Bat_25:
          Bat_state = (unsigned char *)Battery25;    break;
	 case Bat_0:
          Bat_state = (unsigned char *)Battery0;    break;	
  }        
  lcd_PutPicture(Bat_state, 0b11111111, 0b00000011, 18, 80, 1);  
  //Bat_pow_int_str = itoa2(Bat_pow_int); 
  //lcd_PutStr(Bat_pow_int_str,18,70); 
}



//---------    
void DiplayFreq_Normal(void)
{
  char *FrcvWork_str;  
  char *FrcvStep_str = "1";  
  
  Clear_Src();
  //Clear_SrcFull(0, 30, 100, 40, 0b00000011);
  DiplayBatState(); 

  FrcvWork_str = itoa2(FrcvWork);   	
  if(FrcvWork >= 100000)
     lcd_PutStr16x12(FrcvWork_str, 2, 15);
  else
  {   
     lcd_PutChar16x12(0x3A, 2, 15);
     lcd_PutStr16x12(FrcvWork_str, 14, 15);
  }	
  lcd_PutStr("",80,21);  
  
  lcd_PutStrFill("      ",2,2,0b00000011, 0b00000011);           //     
  switch(FindStep)
  {
     case 0:
	    FrcvStep_str = "1"; break;
	 case 1:
	    FrcvStep_str = "5"; break;
     case 2:
	    FrcvStep_str = "10"; break;	
	 case 3:
	    FrcvStep_str = "15"; break;	 
     case 4:
	    FrcvStep_str = "20"; break;	 	
	 case 5:
	    FrcvStep_str = "25"; break;	 
     case 6:
	    FrcvStep_str = "50"; break;	 
     case 7:
	    FrcvStep_str = "100"; break;	
     case 8:
	    FrcvStep_str = "500"; break;	
     case 9:
	    FrcvStep_str = "1"; break;
  	 case 10:
	    FrcvStep_str = "5"; break; 
     case 11:
	    FrcvStep_str = "10"; break; 	
  }
  lcd_PutStrFill("     ",5,2, 0b00000011, 0b11111111);
  lcd_PutStrFill(FrcvStep_str,5,2, 0b11111111,0b00000011);  
  
  if(Stereo_in == WFM_STEREO_IN)
     lcd_PutStrFill("S",40,2, 0b11111111,0b00000011);  
  
  if(Resiver_mode == WFM_STEREO)
     lcd_PutStr("WFM S",48,2);
  if(Resiver_mode == WFM_MONO)
     lcd_PutStr("WFM M",48,2);	
  if(Resiver_mode == NFM)
     lcd_PutStr("NFM  ",48,2);  
  lcd_PutRadioLine(0, 70, 0b11100011, 0b00000000);
  lcd_PutRadioFreqLine(0, 30, FrcvWork, RCV_MAX, RCV_MIN, 0b11100111);	 
}

void DiplayFreq_Change(void)
{ 
  char *FrcvWork_str; 
  static uint32_t FrcvWork_Pre;
   
  FrcvWork_str = itoa2(FrcvWork);   	
  
  if(FrcvWork >= 100000)
     lcd_PutStr16x12(FrcvWork_str, 2, 15);
  else
  {   
     lcd_PutChar16x12(0x3A, 2, 15);
     lcd_PutStr16x12(FrcvWork_str, 14, 15);
  }
   	
  lcd_PutRadioLine(0, 70, 0b11100011, 0b00000000); 
  lcd_PutRadioFreqLine(0, 30, FrcvWork_Pre, RCV_MAX, RCV_MIN, 0b00000011);	      	
  lcd_PutRadioFreqLine(0, 30, FrcvWork, RCV_MAX, RCV_MIN, 0b11100111);	  
  FrcvWork_Pre = FrcvWork;	
}



void DiplayLoadMemoryRadio(int8_t f_no_error)
{
    char *FrcvWork_str;	
	
    if(f_no_error == 1)
    {
       FrcvWork_str = itoa2(FrcvWorkMEM);
       if(FrcvWork >= 100000)
          lcd_PutStrFull(FrcvWork_str, 10, 47, 0b00000011, 0b11111100);
       else
       {   
          lcd_PutChar(0x3A, 10, 31, 0b00000011, 0b11100000);
          lcd_PutStrFull(FrcvWork_str, 15, 47, 0b00000011, 0b11111100);
       }  
       if(Resiver_modeMEM == WFM_STEREO)
          lcd_PutStrFull("WFM S",68,47, 0b00000011, 0b11111100);
       if(Resiver_modeMEM == WFM_MONO)
          lcd_PutStrFull("WFM M",68,47, 0b00000011, 0b11111100);	
       if(Resiver_modeMEM == NFM)
          lcd_PutStrFull("NFM  ",68,47, 0b00000011, 0b11111100);  
    }
    else
        lcd_PutStrFull("......", 10, 47, 0b00000011, 0b11111100);   		
}

//---------     
void DiplayMemoryRadio(void)
{
   char *FrcvWork_str;
   char *n_cell_str;
   uint16_t n_cell;
   char num_menu = 12;
   static int8_t f_no_error;
         
		 
   Clear_Src();	
   DiplayBatState(); 
 
   lcd_PutStrFill(" ",5,13, 0b11111111,0b00000011);  

   if(menu_radio == SAVE)     num_menu = 23;
   if(menu_radio == LOAD)     num_menu = 39;
   if(menu_radio == EXIT)     num_menu = 55;
   
   lcd_PutSimol(1, 2, num_menu, 0b00000011, 0b11100000);   //      

   //----------     
   lcd_PutStr(" .",10,23);
   n_cell = (Mem_W_cell - 20)>>2;   
   
   n_cell_str = itoa2(n_cell); 
   lcd_PutStr(n_cell_str,70,23);
   
   if(f_Memwrite == TRUE) 
      lcd_PutStr("C.",80,23);  
   
   FrcvWork_str = itoa2(FrcvWork); 
   if(FrcvWork >= 100000)
     lcd_PutStrFull(FrcvWork_str, 10, 31, 0b00000011, 0b11111100);
   else
   {   
     lcd_PutChar(0x3A, 10, 31, 0b00000011, 0b11100000);
     lcd_PutStrFull(FrcvWork_str, 15, 31, 0b00000011, 0b11111100);
   }
   
   lcd_PutStrFull("",47, 31, 0b00000011, 0b11111100);
   if(Resiver_mode == WFM_STEREO)
      lcd_PutStrFull("WFM S",68,31, 0b00000011, 0b11111100);
   if(Resiver_mode == WFM_MONO)
      lcd_PutStrFull("WFM M",68,31, 0b00000011, 0b11111100);	
   if(Resiver_mode == NFM)
      lcd_PutStrFull("NFM  ",68,31, 0b00000011, 0b11111100);  
      
   //----------    
   lcd_PutStr(" .",10,39); 
   n_cell = (Mem_R_cell - 20)>>2;   
   
   n_cell_str = itoa2(n_cell); 
   lcd_PutStr(n_cell_str,70,39);
   if(menu_radio == LOAD)
   {
      if((IndMEM != Mem_R_cell) || f_Memwrite == TRUE)
      { 
         IndMEM = Mem_R_cell; 
         f_no_error = rMEM_Freq(); 
      }
      DiplayLoadMemoryRadio(f_no_error);
           
      lcd_PutStrFull("",47, 47, 0b00000011, 0b11111100);
	  f_Memwrite = FALSE;
   }
      
   lcd_PutStr("",10,55); 
}

void DiplayMemoryRadio_ChangePosition(void)
{
   char num_menu = 12;
   char num_menu_pred = 12;
   
   if(menu_radio == SAVE)  {  num_menu = 23; num_menu_pred = 55;  }
   if(menu_radio == LOAD)  {  num_menu = 39; num_menu_pred = 23;  }
   if(menu_radio == EXIT)  {  num_menu = 55; num_menu_pred = 39;  }
   
   
   lcd_PutStr(" ",2,num_menu_pred);
   lcd_PutSimol(1, 2, num_menu, 0b00000011, 0b11100000);   //  
}


void DiplayMemoryRadio_W_cellChange(void)
{
   uint16_t n_cell;
   char *n_cell_str;
   
   lcd_PutStr("   ",70,23);
   n_cell = (Mem_W_cell - 20)>>2;   
   n_cell_str = itoa2(n_cell); 
   lcd_PutStr(n_cell_str,70,23);
}


//---------    
void DiplayMENURadio(void)
{
   char num_menu = 12;
   char *Param_str;

   Clear_Src();
   DiplayBatState();  
	 
   lcd_PutStrFill("",5,13, 0b11111111,0b00000011);  

   if(menu_option == APU)       num_menu = 23;
   if(menu_option == View)      num_menu = 32;
   if(menu_option == ARU)       num_menu = 41;
   if(menu_option == SLEEP)     num_menu = 50;
   if(menu_option == BRUST)     num_menu = 59;
   if(menu_option == QUARZ  ||  
      menu_option == SAVE_O ||  
      menu_option == EXIT_O)    num_menu = 68;
   
   lcd_PutSimol(1, 2, num_menu, 0b00000011, 0b11100000);   // 
   
   if(menu_option != SAVE_O && menu_option != EXIT_O)
   {
      Param_str = itoa2(APU_int); 
      lcd_PutStr(Param_str,64,23);
      lcd_PutStr("SQL .=" ,10,23);  
      lcd_PutStr("     =",10,32); 
      if(N_View == NI_MH)
         lcd_PutStr("NI-MH" ,64,32); 
      if(N_View == AAx3)
         lcd_PutStr("AAx3",64,32);
      if(N_View == LI_ION)
         lcd_PutStr("LI-ION",64,32);
      Param_str = itoa2(ARU_int);  
      lcd_PutStr(Param_str,64,41); 
      lcd_PutStr("     ="       ,10,41);
      Param_str = itoa2(Sleep_int); 
      lcd_PutStr(Param_str,64,50); 
      lcd_PutStr("()=" ,10,50);
	  lcd_PutStr(".. =",10,59);
	  if(BRUST_int == On)
	     lcd_PutStr("",64,59); 
	  else
         lcd_PutStr("",64,59);   	 
	  lcd_PutStr("   =" ,10,68);   	
	  if(Quarz_int == Q_7_2MHz)
	     lcd_PutStr("7.2",64,68);
	  else
         lcd_PutStr("4.5",64,68); 
   } 
   if(menu_option == SAVE_O)
   {
      lcd_PutStr("     =",10,23); 
      if(N_View == NI_MH)
         lcd_PutStr("NI-MH" ,64,23); 
      if(N_View == AAx3)
         lcd_PutStr("AAx3",64,23);
      if(N_View == LI_ION)
         lcd_PutStr("LI-ION",64,23);
      Param_str = itoa2(ARU_int);  
      lcd_PutStr(Param_str,64,32); 
      lcd_PutStr("     ="       ,10,32);
      Param_str = itoa2(Sleep_int); 
      lcd_PutStr(Param_str,64,41); 
      lcd_PutStr("()=" ,10,41);
	  lcd_PutStr(".. =" ,10,50);
	  if(BRUST_int == On)
	     lcd_PutStr("",64,50); 
	  else
         lcd_PutStr("",64,50);   	 
	  lcd_PutStr("   =" ,10,59);   	
	  if(Quarz_int == Q_7_2MHz)
	     lcd_PutStr("7.2",64,59);
	  else
         lcd_PutStr("4.5",64,59);  
	  lcd_PutStr("" ,10,68);
      if(f_Memwrite == TRUE) 
      {
         f_Memwrite = FALSE;
	     lcd_PutStr("." ,62,68);
      }	 
   }
   if(menu_option == EXIT_O)
   {      
      Param_str = itoa2(ARU_int);  
      lcd_PutStr(Param_str,64,23); 
      lcd_PutStr("     ="       ,10,23);
      Param_str = itoa2(Sleep_int); 
      lcd_PutStr(Param_str,64,32); 
      lcd_PutStr("()=" ,10,32);
	  lcd_PutStr(".. =",10,41);
	  if(BRUST_int == On)
	     lcd_PutStr("",64,41); 
	  else
         lcd_PutStr("",64,41);   	 
	  lcd_PutStr("   =" ,10,50);   	
	  if(Quarz_int == Q_7_2MHz)
	     lcd_PutStr("7.2",64,50);
	  else
         lcd_PutStr("4.5",64,50);  
	  lcd_PutStr("" ,10,59);
      if(f_Memwrite == TRUE) 
      {
         f_Memwrite = FALSE;
	     lcd_PutStr("." ,62,59);
      }	
      lcd_PutStr("" ,10,68);  
   }
  
     	
}

/*void DiplayMENURadio_ChangePosition(void)
{
   char num_menu = 12;
   char num_menu_pred = 12;

   if(menu_option == APU)    {  num_menu = 23;   num_menu_pred = 68;  }
   if(menu_option == View)   {  num_menu = 32;   num_menu_pred = 23;  }
   if(menu_option == ARU)    {  num_menu = 41;   num_menu_pred = 32;  }
   if(menu_option == SLEEP)  {  num_menu = 50;   num_menu_pred = 41;  }
   if(menu_option == BRUST)  {  num_menu = 59;   num_menu_pred = 50;  }   
   if(menu_option == QUARZ ||
      menu_option == SAVE_O||   
	  menu_option == EXIT_O) {  num_menu = 68;   num_menu_pred = 59;  }     
   lcd_PutStr(" ",2,num_menu_pred);
   lcd_PutSimol(1, 2, num_menu, 0b00000011, 0b11100000);   // 
}*/


void DiplayMENURadio_APUChange(void)
{   
   char *Param_str;      
   lcd_PutStr("   ",64,23);
   Param_str = itoa2(APU_int); 
   lcd_PutStr(Param_str,64,23); 
} 

void DiplayMENURadio_ViewChange(void)
{
   if(N_View == NI_MH)
      lcd_PutStr("NI-MH ",64,32); 
   if(N_View == AAx3)
      lcd_PutStr("AAx3  ",64,32);
   if(N_View == LI_ION)
      lcd_PutStr("LI-ION",64,32);
}

void DiplayMENURadio_ARUChange(void)
{
   char *Param_str;

   lcd_PutStr("   ",64,41);
   Param_str = itoa2(ARU_int);  
   lcd_PutStr(Param_str,64,41); 
}
void DiplayMENURadio_SleepChange(void)
{
   char *Param_str;  
   
   lcd_PutStr("  ",64,50);
   Param_str = itoa2(Sleep_int); 
   lcd_PutStr(Param_str,64,50);
   
}

void DiplayMENURadio_BRUSTChange(void)
{
   lcd_PutStr("    ",64,59);   
   if(BRUST_int == On)
      lcd_PutStr("",64,59);   
   else
      lcd_PutStr("",64,59); 	  
}

void DiplayMENURadio_QuarzChange(void)
{
   lcd_PutStr("      ",64,68);
   if(Quarz_int == Q_7_2MHz)
      lcd_PutStr("7.2",64,68);  
   else
      lcd_PutStr("4.5",64,68); 
}




//
ISR(ADC_vect)
{
   adc_bat  = ADC;
   if(adc_count < 100)   
   {   
      adc_bat_sum = adc_bat_sum + adc_bat;
	  adc_count++;
   }
   else
   {
      adc_bat = (unsigned int)(adc_bat_sum/100);
	  adc_bat_sum = 0;
	  adc_count = 0;
	  f_adc = 1; 
   }    
}
//--------------------------------------------//
//----------0  
//--------------------------------------------//
ISR(TIMER0_OVF_vect)
{
   TCNT0 = 0x64; //reload counter value
   
   if(f_butS == FALSE)
   {
   
      if(f_press_butS == FALSE)
      {  
         if(GetState(BUT_IN, BUT_S_Bit) == 0)//GetBit(BUT_IN, BUT_S_Bit)== 0)  
	     {    
	         if(press_countS != 200)
		        press_countS++;
		     else
                f_press_butS = TRUE;	
	     }
         else
         {    
            if(press_countS > 10)
               f_butS = TRUE; 
            press_countS = 0;
         }
      }
      else
      {
         if(press_countS == 200)                    
            f_butS_3c = TRUE;         
         else         
            f_butS_3c = FALSE;
         press_countS = 0;
         f_press_butS = FALSE;
         f_butS = TRUE; 	  	 	      
      }
   } 
   if(f_butM == FALSE)
   {   
      if(f_press_butM == FALSE)
      {  
         if(GetState(BUT_IN, BUT_M_Bit) == 0)//GetBit(BUT_IN, BUT_S_Bit)== 0)  
	     {    
	         if(press_countM != 200)
		        press_countM++;
		     else
                f_press_butM = TRUE;	
	     }
         else
         {    
            if(press_countM > 10)
               f_butM = TRUE;
            press_countM = 0;                                   
         }
      }
      else
      {
         if(press_countM == 200)                    
            f_butM_3c = TRUE;         
         else         
            f_butM_3c = FALSE;
         press_countM = 0;
         f_press_butM = FALSE;
         f_butM = TRUE; 	  	 	      
      }
   } 
   if(f_sleep == FALSE)
   {
      sleep_count++;
      sleep_countS = (unsigned char)(sleep_count/100);
      if(Sleep_int <= sleep_countS)
      {
         sleep_count = 0;
		 f_sleep = TRUE;
      } 
   }          
}
//--------------------------------------------//
//        
void Set_Regim(void)
{
    switch(Resiver_mode)
	{
	   case WFM_STEREO:   
	        Resiver_mode = WFM_MONO;   
			Stereo_Mono  = WFM_MONO;   
			SetBit(NFMWFM_Port,NFMWFM_Bit);  // FM
			Lc72131Set();
			break;
	   case WFM_MONO:     
	        Resiver_mode = NFM;        
			ClrBit(NFMWFM_Port,NFMWFM_Bit);
			break;
	   case NFM:          
	        Resiver_mode = WFM_STEREO; 
			Stereo_Mono  = WFM_STEREO;  
			SetBit(NFMWFM_Port,NFMWFM_Bit);
			Lc72131Set();
			break;
	}
	 
}

void ReadBatState(void)
{    
        
    //adc_init(ADC_BAT_CH); 
    //_delay_us(10);
	cli();
	if(f_adc == 1)
	{
	   f_adc = 0; 
	   Bat_pow_int = adc_bat; 
    }     
    sei();
   
    if( Bat_pow_int > 0)
	{
       switch(N_View)
	   {
	     case NI_MH:
	        if(Bat_pow_int >= ADC_BAT_NI_MH_75 )                                    Bat_pow = Bat_75;
            if(Bat_pow_int >= ADC_BAT_NI_MH_50 && Bat_pow_int  < ADC_BAT_NI_MH_75)  Bat_pow = Bat_50;
            if(Bat_pow_int >= ADC_BAT_NI_MH_25  && Bat_pow_int  < ADC_BAT_NI_MH_50) Bat_pow = Bat_25;    
            if(Bat_pow_int < ADC_BAT_NI_MH_25)                                       Bat_pow = Bat_0;   
		    break;
	      case AAx3:
	        if(Bat_pow_int >= ADC_BAT_AAx3_75 )                                    Bat_pow = Bat_75;
            if(Bat_pow_int >= ADC_BAT_AAx3_50 && Bat_pow_int  < ADC_BAT_AAx3_75)  Bat_pow = Bat_50;
            if(Bat_pow_int >= ADC_BAT_AAx3_25  && Bat_pow_int  < ADC_BAT_AAx3_50) Bat_pow = Bat_25;    
            if(Bat_pow_int < ADC_BAT_AAx3_25)                                       Bat_pow = Bat_0;   
		    break;
	      case LI_ION:
	        if(Bat_pow_int >= ADC_BAT_LION_75 )                                   Bat_pow = Bat_75;
            if(Bat_pow_int >= ADC_BAT_LION_50 && Bat_pow_int  < ADC_BAT_LION_75)  Bat_pow = Bat_50;
            if(Bat_pow_int >= ADC_BAT_LION_25  && Bat_pow_int  < ADC_BAT_LION_50) Bat_pow = Bat_25;    
            if(Bat_pow_int < ADC_BAT_LION_25)                                      Bat_pow = Bat_0;   
		    break;
	   }        
    }  
}

void ReadLC72131State(void)
{  
    //char *IO_str;
	//int adc_fm=0;
	//uint32_t adc_tek;

    Lc72131Get();
    Stereo_in = StereoMono_In;
    if(Stereo_in == WFM_STEREO_IN)
       lcd_PutStrFill("S",40,2, 0b11111111,0b00000011);
    else
       lcd_PutStrFill(" ",40,2, 0b00000011, 0b11111111);      
    //Lc72131GetFreq();
	/*LC72131GetFreq();
	IO_str = itoa2(FrcvSQL);
	lcd_PutStrFill(IO_str,45,50, 0b00000011, 0b11111111); */
	_delay_ms(1);
}


void Scan(void)
{
    char *adc_str;
    static uint32_t FrcvWork_save;
	char f_Find = FALSE;
	int adc_fm=0;
    uint32_t adc_tek;
	 
	if(f_SCAN_fist == TRUE)
	{
	   FrcvWork_save = FrcvWork;
	   UapuB_Out(255);
	   f_SCAN_fist = FALSE;
	}	
	 	
	if(FrcvWork < (RCV_MAX - Step[FindStep]))
    {   
	   FrcvWork = FrcvWork + Step[FindStep]; 
	   
	   Lc72131Set(); 
       KSH14xPLL2();
	   _delay_ms(1000);
       adc_tek = 0;
	   for(unsigned int m=0; m<512; m++)
	   {
	      adc_init(ADC_SCAN_CH);
	      adc_fm = adc_read();
	      adc_tek += adc_fm;
	   }	
	   adc_tek = adc_tek>>9;
	   adc_str = itoa2(adc_tek);
	   lcd_PutStrFill(adc_str,45,50, 0b00000011, 0b11111111);  
       if(adc_tek < 300)
	   {   
	      f_Find = TRUE;
		  f_SCAN = FALSE;  
	   } 
	   if(f_butS == TRUE)
       {
	      sleep_count = 0;
	      f_butS = FALSE;     	  
	   }
    }	
	else
	   f_SCAN = FALSE;   
	
	if(f_SCAN == FALSE)
	{
	   if(f_Find == FALSE)
	   {
	      UapuB_Out(APU_int);
	      FrcvWork = FrcvWork_save;
	      Lc72131Set(); 
          KSH14xPLL2();
	   }	  
	}	
}

void SignalView(void)
{
    char *adc_str;    
	int adc_fm=0;
    uint32_t adc_tek;	 
	unsigned char m;
		
	adc_tek = 0;
	for(m=0; m<102; m++)
	{
	   adc_init(ADC_SCAN_CH);
	   adc_fm = adc_read();
	   adc_fm = -adc_fm/14 + 80;
	   DRAM[m] = (unsigned char)adc_fm;
	}	
	
	Clear_SrcFull(0, 30, 100, 50, 0b00000011); 
	lcd_PutSignal(DRAM, 0b00000011, 0b11111111, 102, 0, 30); 
	adc_tek = adc_tek>>9;
	adc_str = itoa2(adc_fm);
	lcd_PutStrFill(adc_str,80,12, 0b00000011, 0b11111111);		
}    


//----------------------------- ----------------------------//
ISR(TIMER2_OVF_vect)
{
   TCNT2 = 0x83; //reload counter value
   EncPoll();   
   state_count++;
   if(state_count == 250) // 
   {
     state_count = 0;
	 f_state     = TRUE;
   }
   
}
//------------------------------------------------------------------------//

void LoadOptionFromEEPROM(void)
{
   if(rMEM_Options())
   {
      APU_int         = APU_intMEM;
      N_View          = N_ViewMEM;
	  ARU_int         = ARU_intMEM;
	  Sleep_int       = Sleep_intMEM;
	  FindStep        = FindStepMEM;
      FrcvWork        = FrcvWorkMEM;
      Resiver_mode    = Resiver_modeMEM;
      BRUST_int       = BRUST_intMEM;
      Quarz_int       = Quarz_intMEM;	  
   }
} 


int main(void) 
{  
  unsigned char n;

  init_devices();
		
  InitLCD(); 		
  Clear_Src();
	
  FrcvWork   = 105200; 
  LoadOptionFromEEPROM();
  DiplayFreq_Normal();
  
  ON_Light();  
  UapuB_Out(APU_int); 
  UapyA_Out(ARU_int);    
  Lc72131Set(); 
  KSH14xPLL2();   	
  
  while(1)
  {
     //----------------------  
	 if(Param != 0)
	 {
        switch(Radio_Mode) 
        {  
		    //---------------  
            case RADIO:                  
	           cli();
			   n = Param;
			   Param = 0;
			   sei();
			   if(n == RIGHT_SPIN) //  
               {
			      if(FrcvWork < (RCV_MAX - Step[FindStep]))
                     FrcvWork = FrcvWork + Step[FindStep]; 					 	
				   
               }    
               if(n == LEFT_SPIN)  //  
               {
			      if(FrcvWork > (RCV_MIN + Step[FindStep]))
                     FrcvWork = FrcvWork - Step[FindStep]; 
				 
               }
			   //Param = 0;
		       Lc72131Set(); //       
               KSH14xPLL2(); //   	
			   DiplayFreq_Change();            
               break;
		   //----------    
           case MENU: 
               switch(menu_option)  
               {
			     case APU:   //   -  
				    if(Param == RIGHT_SPIN) APU_int++;
					if(Param == LEFT_SPIN)  APU_int--;
                    UapuB_Out(APU_int); 
                    DiplayMENURadio_APUChange();				    
					break;
			     case View:   //
                    if(Param == RIGHT_SPIN) 
					{
					   switch(N_View)
					   {
					      case NI_MH:     N_View = AAx3;       break;
						  case AAx3:      N_View = LI_ION;     break;
						  case LI_ION:    N_View = NI_MH;      break;
					   }					   
					   
					}
					if(Param == LEFT_SPIN)  
					{  
					   switch(N_View)
					   {
					      case NI_MH:     N_View = LI_ION;     break;
						  case LI_ION:    N_View = AAx3;       break;
						  case AAx3:      N_View = NI_MH;      break;
					   }
					}
					DiplayMENURadio_ViewChange();
					break;
                 case ARU:   //   
                    if(Param == RIGHT_SPIN) ARU_int++;
					if(Param == LEFT_SPIN)  ARU_int--;
					UapyA_Out(ARU_int);
					DiplayMENURadio_ARUChange();
					break;
                 case SLEEP: //        
                    if(Param == RIGHT_SPIN) if(Sleep_int < SLEEP_MAX) Sleep_int++;
					if(Param == LEFT_SPIN)  if(Sleep_int > SLEEP_MIN) Sleep_int--;
					DiplayMENURadio_SleepChange();
					break;  
	             case BRUST: 
				    if(BRUST_int == On) BRUST_int = Off;
					else                 BRUST_int = On;
					DiplayMENURadio_BRUSTChange();
					break;
				 case QUARZ: 
				    if(Quarz_int == Q_7_2MHz) Quarz_int = Q_4_5MHz;
					else                       Quarz_int = Q_7_2MHz;
					DiplayMENURadio_QuarzChange();
					break;  	
			   } 	
               //f_change = TRUE;              
               break; 	
           //----------       
           case MENU_MEMORY:
               switch(menu_radio)
               {
                 case SAVE: //     
                    if(Param == RIGHT_SPIN) if(Mem_W_cell < N_MEM_RADIO_MAX) Mem_W_cell = Mem_W_cell + 4;
                    if(Param == LEFT_SPIN)  if(Mem_W_cell > N_MEM_RADIO_MIN) Mem_W_cell = Mem_W_cell - 4;
                    DiplayMemoryRadio_W_cellChange();
					break;
                 case LOAD: //     
                    if(Param == RIGHT_SPIN) if(Mem_R_cell < N_MEM_RADIO_MAX) Mem_R_cell = Mem_R_cell + 4;
                    if(Param == LEFT_SPIN)  if(Mem_R_cell > N_MEM_RADIO_MIN) Mem_R_cell = Mem_R_cell - 4;
                    f_change = TRUE;  
					break; 
               }                              
               break;     
        }
		sleep_count = 0;
        Param = 0;    
	 }	
	 
	 if(f_butM == TRUE)  //  
	 { 
        switch(Radio_Mode) 
        {
           //-----------  
           case RADIO:               
              if(f_butM_3c == FALSE) //  2 
		         Set_Regim();
              else                    // 2  
              {                    
                 DiplayMemoryRadio();
                 while(GetState(BUT_IN, BUT_M_Bit) == 0);	//   			 
                 Radio_Mode =  MENU_MEMORY;
				 Clear_Src();				 
              }
			  f_butM_3c = FALSE;
			  f_change = TRUE;
			  break;
           //----------    
           case MENU: 
		      switch(menu_option)
              {
			      case SAVE_O:  //    -       
				    APU_intMEM      = APU_int;
                    N_ViewMEM       = N_View;
	                ARU_intMEM      = ARU_int;
	                Sleep_intMEM    = Sleep_int;
					FindStepMEM     = FindStep;
                    FrcvWorkMEM     = FrcvWork;
                    Resiver_modeMEM = Resiver_mode;
					BRUST_intMEM    = BRUST_int;
                    Quarz_intMEM    = Quarz_int;
                    wMEM_Options();
					f_Memwrite = TRUE;
					break;
				  case EXIT_O: //    -   
				    Radio_Mode =  RADIO;
				    Clear_Src();
					break;
			  }
			  f_change = TRUE;
              break;
           //----------       
           case MENU_MEMORY:
              switch(menu_radio)
              {
                 case SAVE:     menu_radio = LOAD;      break; //   
                 case LOAD:     menu_radio = EXIT;      break; //   
                 case EXIT:     menu_radio = SAVE;      break; //                
              } 
			  DiplayMemoryRadio_ChangePosition();
              break;  
        }
		sleep_count = 0;		
        f_butM = FALSE; 
	 }
	 if(f_butS == TRUE)  //  
	 {      
        switch(Radio_Mode) 
        {
           //-----------  
           case RADIO:         
		      if(f_butS_3c == FALSE) //  2 
		      {
		         if(FindStep != STEPS_MAX) FindStep++;
		         else                       FindStep = 0;                               
              }
			  else                   // 2 
			  {
			     DiplayMENURadio();
				 while(GetState(BUT_IN, BUT_S_Bit) == 0);	//   
                 Radio_Mode =  MENU;
                 Clear_Src(); 	
			  }
			  f_change = TRUE; 
			  f_butS_3c = FALSE;
              break;
           //----------    
           case MENU: 
		      switch(menu_option)
              { 
			     case APU:    menu_option = View;    break;//   SQL
			     case View:   menu_option = ARU;     break;//                       
                 case ARU:    menu_option = SLEEP;   break;//                         
                 case SLEEP:  menu_option = BRUST;   break;//   .
				 case BRUST:  menu_option = QUARZ;   break;//    				 
				 case QUARZ:  menu_option = SAVE_O;  break;//   
				 case SAVE_O: menu_option = EXIT_O;  break;//   
				 case EXIT_O: menu_option = APU;     break;//   
			  } 
			  //DiplayMENURadio_ChangePosition();
			  f_change = TRUE; 
              break;
           //----------       
           case MENU_MEMORY:
              switch(menu_radio)
              {
                 case SAVE:   //    -    
                    IndMEM          = Mem_W_cell;
                    FrcvWorkMEM     = FrcvWork;
                    Resiver_modeMEM = Resiver_mode;
                    wMEM_Freq();
					f_Memwrite = TRUE;
                    break;
                 case LOAD:  //    -    
                    {
                       if(rMEM_Freq())
					   {					   
					      FrcvWork     = FrcvWorkMEM;
                          Resiver_mode = Resiver_modeMEM;
					      Lc72131Set(); //       
                          KSH14xPLL2(); //   
					   }	  
                    }
                    break;                      
                 case EXIT:   //    -    
                    Radio_Mode = RADIO;
					Clear_Src();                    
                    break; 
              }    
			  f_change = TRUE; 
              break;  
		}  	
        sleep_count = 0;	
		f_butS = FALSE;  
	 }
	 if(f_change == TRUE)  //    
	 {
	    f_change = FALSE; 
		switch(Radio_Mode) 
        {
		   //----------  
		   case RADIO:       //   	      
			  DiplayFreq_Normal();		  
			  break;
		   //----------    
           case MENU:        //   
		       DiplayMENURadio();
              break;  
		   //----------       
           case MENU_MEMORY: //   
              DiplayMemoryRadio();
              break;  	  
		}
	 } 	
	 
	 if(f_state == TRUE)
	 {  
	    f_state = FALSE;
	    ReadBatState();      //      
		DiplayBatState();
		ReadLC72131State();  //      
	 }	
	 
     if(f_sleep == TRUE)      //  
	 {
	    OFF_Light();
		Go_To_Sleep();
		f_sleep = FALSE;
	 }
	 if(f_WakeUP == TRUE)    //  
     {
	    ON_Light();
	    Go_To_WakeUp();
		f_WakeUP = FALSE;
     } 	 
  }
	
  return 0;
}     
